diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-option-header.h ns-3.34/src/internet/model/ipv6-option-header.h
--- ns-3.33/src/internet/model/ipv6-option-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-option-header.h	2021-07-14 10:31:06.000000000 -0700
@@ -99,7 +99,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -181,7 +180,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -239,7 +237,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -308,7 +305,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
@@ -389,7 +385,6 @@
   /**
    * \brief Print some information about the packet.
    * \param os output stream
-   * \return info about this packet
    */
   virtual void Print (std::ostream &os) const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-static-routing.cc ns-3.34/src/internet/model/ipv6-static-routing.cc
--- ns-3.33/src/internet/model/ipv6-static-routing.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-static-routing.cc	2021-07-14 10:31:06.000000000 -0700
@@ -83,6 +83,11 @@
 {
   NS_LOG_FUNCTION (this << stream);
   std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv6->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
@@ -97,9 +102,9 @@
           std::ostringstream dest, gw, mask, flags;
           Ipv6RoutingTableEntry route = GetRoute (j);
           dest << route.GetDest () << "/" << int(route.GetDestNetworkPrefix ().GetPrefixLength ());
-          *os << std::setiosflags (std::ios::left) << std::setw (31) << dest.str ();
+          *os << std::setw (31) << dest.str ();
           gw << route.GetGateway ();
-          *os << std::setiosflags (std::ios::left) << std::setw (27) << gw.str ();
+          *os << std::setw (27) << gw.str ();
           flags << "U";
           if (route.IsHost ())
             {
@@ -109,8 +114,8 @@
             {
               flags << "G";
             }
-          *os << std::setiosflags (std::ios::left) << std::setw (5) << flags.str ();
-          *os << std::setiosflags (std::ios::left) << std::setw (4) << GetMetric (j);
+          *os << std::setw (5) << flags.str ();
+          *os << std::setw (4) << GetMetric (j);
           // Ref ct not implemented
           *os << "-" << "   ";
           // Use not implemented
@@ -127,6 +132,8 @@
         }
     }
   *os << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 void Ipv6StaticRouting::AddHostRouteTo (Ipv6Address dst, Ipv6Address nextHop, uint32_t interface, Ipv6Address prefixToUse, uint32_t metric)
@@ -149,9 +156,14 @@
 void Ipv6StaticRouting::AddNetworkRouteTo (Ipv6Address network, Ipv6Prefix networkPrefix, Ipv6Address nextHop, uint32_t interface, uint32_t metric)
 {
   NS_LOG_FUNCTION (this << network << networkPrefix << nextHop << interface << metric);
-  Ipv6RoutingTableEntry* route = new Ipv6RoutingTableEntry ();
-  *route = Ipv6RoutingTableEntry::CreateNetworkRouteTo (network, networkPrefix, nextHop, interface);
-  m_networkRoutes.push_back (std::make_pair (route, metric));
+
+  Ipv6RoutingTableEntry route = Ipv6RoutingTableEntry::CreateNetworkRouteTo (network, networkPrefix, nextHop, interface);
+
+  if (!LookupRoute (route, metric))
+    {
+      Ipv6RoutingTableEntry* routePtr = new Ipv6RoutingTableEntry (route);
+      m_networkRoutes.push_back (std::make_pair (routePtr, metric));
+    }
 }
 
 void Ipv6StaticRouting::AddNetworkRouteTo (Ipv6Address network, Ipv6Prefix networkPrefix, Ipv6Address nextHop, uint32_t interface, Ipv6Address prefixToUse, uint32_t metric)
@@ -162,17 +174,24 @@
       NS_LOG_WARN ("Ipv6StaticRouting::AddNetworkRouteTo - Next hop should be link-local");
     }
 
-  Ipv6RoutingTableEntry* route = new Ipv6RoutingTableEntry ();
-  *route = Ipv6RoutingTableEntry::CreateNetworkRouteTo (network, networkPrefix, nextHop, interface, prefixToUse);
-  m_networkRoutes.push_back (std::make_pair (route, metric));
+  Ipv6RoutingTableEntry route = Ipv6RoutingTableEntry::CreateNetworkRouteTo (network, networkPrefix, nextHop, interface, prefixToUse);
+  if (!LookupRoute (route, metric))
+    {
+      Ipv6RoutingTableEntry* routePtr = new Ipv6RoutingTableEntry (route);
+      m_networkRoutes.push_back (std::make_pair (routePtr, metric));
+    }
 }
 
 void Ipv6StaticRouting::AddNetworkRouteTo (Ipv6Address network, Ipv6Prefix networkPrefix, uint32_t interface, uint32_t metric)
 {
   NS_LOG_FUNCTION (this << network << networkPrefix << interface);
-  Ipv6RoutingTableEntry* route = new Ipv6RoutingTableEntry ();
-  *route = Ipv6RoutingTableEntry::CreateNetworkRouteTo (network, networkPrefix, interface);
-  m_networkRoutes.push_back (std::make_pair (route, metric));
+
+  Ipv6RoutingTableEntry route = Ipv6RoutingTableEntry::CreateNetworkRouteTo (network, networkPrefix, interface);
+  if (!LookupRoute (route, metric))
+    {
+      Ipv6RoutingTableEntry* routePtr = new Ipv6RoutingTableEntry (route);
+      m_networkRoutes.push_back (std::make_pair (routePtr, metric));
+    }
 }
 
 void Ipv6StaticRouting::SetDefaultRoute (Ipv6Address nextHop, uint32_t interface, Ipv6Address prefixToUse, uint32_t metric)
@@ -281,6 +300,25 @@
   return false;
 }
 
+bool Ipv6StaticRouting::LookupRoute (const Ipv6RoutingTableEntry &route, uint32_t metric)
+{
+  for (NetworkRoutesI j = m_networkRoutes.begin (); j != m_networkRoutes.end (); j++)
+    {
+      Ipv6RoutingTableEntry* rtentry = j->first;
+
+      if (rtentry->GetDest () == route.GetDest () &&
+          rtentry->GetDestNetworkPrefix () == route.GetDestNetworkPrefix () &&
+          rtentry->GetGateway () == route.GetGateway () &&
+          rtentry->GetInterface () == route.GetInterface () &&
+          rtentry->GetPrefixToUse () == route.GetPrefixToUse () &&
+          j->second == metric)
+        {
+          return true;
+        }
+    }
+  return false;
+}
+
 Ptr<Ipv6Route> Ipv6StaticRouting::LookupStatic (Ipv6Address dst, Ptr<NetDevice> interface)
 {
   NS_LOG_FUNCTION (this << dst << interface);
@@ -646,18 +684,23 @@
 {
   for (uint32_t j = 0; j < m_ipv6->GetNAddresses (i); j++)
     {
-      if (m_ipv6->GetAddress (i, j).GetAddress () != Ipv6Address ()
-          && m_ipv6->GetAddress (i, j).GetPrefix () != Ipv6Prefix ())
+      Ipv6InterfaceAddress addr = m_ipv6->GetAddress (i, j);
+
+      if (addr.GetAddress () != Ipv6Address ()
+          && addr.GetPrefix () != Ipv6Prefix ())
         {
-          if (m_ipv6->GetAddress (i, j).GetPrefix () == Ipv6Prefix (128))
+          if (addr.GetPrefix () == Ipv6Prefix (128))
             {
               /* host route */
-              AddHostRouteTo (m_ipv6->GetAddress (i, j).GetAddress (), i);
+              AddHostRouteTo (addr.GetAddress (), i);
             }
           else
             {
-              AddNetworkRouteTo (m_ipv6->GetAddress (i, j).GetAddress ().CombinePrefix (m_ipv6->GetAddress (i, j).GetPrefix ()),
-                                 m_ipv6->GetAddress (i, j).GetPrefix (), i);
+              if (addr.GetOnLink ())
+                {
+                  AddNetworkRouteTo (addr.GetAddress ().CombinePrefix (addr.GetPrefix ()),
+                                     addr.GetPrefix (), i);
+                }
             }
         }
     }
@@ -688,14 +731,6 @@
     {
       return;
     }
-
-  Ipv6Address networkAddress = address.GetAddress ().CombinePrefix (address.GetPrefix ());
-  Ipv6Prefix networkMask = address.GetPrefix ();
-
-  if (address.GetAddress () != Ipv6Address () && address.GetPrefix () != Ipv6Prefix ())
-    {
-      AddNetworkRouteTo (networkAddress, networkMask, interface);
-    }
 }
 
 void Ipv6StaticRouting::NotifyRemoveAddress (uint32_t interface, Ipv6InterfaceAddress address)
@@ -730,7 +765,11 @@
 void Ipv6StaticRouting::NotifyAddRoute (Ipv6Address dst, Ipv6Prefix mask, Ipv6Address nextHop, uint32_t interface, Ipv6Address prefixToUse)
 {
   NS_LOG_INFO (this << dst << mask << nextHop << interface << prefixToUse);
-  if (dst != Ipv6Address::GetZero ())
+  if (nextHop == Ipv6Address::GetZero ())
+    {
+      AddNetworkRouteTo (dst, mask, interface);
+    }
+  else if (dst != Ipv6Address::GetZero ())
     {
       AddNetworkRouteTo (dst, mask, nextHop, interface);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ipv6-static-routing.h ns-3.34/src/internet/model/ipv6-static-routing.h
--- ns-3.33/src/internet/model/ipv6-static-routing.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ipv6-static-routing.h	2021-07-14 10:31:06.000000000 -0700
@@ -265,6 +265,14 @@
   typedef std::list<Ipv6MulticastRoutingTableEntry *>::iterator MulticastRoutesI;
 
   /**
+   * \brief Checks if a route is already present in the forwarding table.
+   * \param route route
+   * \param metric metric of route
+   * \return true if the route/metric is already in the forwarding table
+   */
+  bool LookupRoute (const Ipv6RoutingTableEntry &route, uint32_t metric);
+
+  /**
    * \brief Lookup in the forwarding table for destination.
    * \param dest destination address
    * \param interface output interface if any (put 0 otherwise)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ndisc-cache.cc ns-3.34/src/internet/model/ndisc-cache.cc
--- ns-3.33/src/internet/model/ndisc-cache.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ndisc-cache.cc	2021-07-14 10:31:06.000000000 -0700
@@ -409,6 +409,12 @@
   m_ipv6Address = ipv6Address;
 }
 
+Ipv6Address NdiscCache::Entry::GetIpv6Address (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_ipv6Address;
+}
+
 Time NdiscCache::Entry::GetLastReachabilityConfirmation () const
 {
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ndisc-cache.h ns-3.34/src/internet/model/ndisc-cache.h
--- ns-3.33/src/internet/model/ndisc-cache.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ndisc-cache.h	2021-07-14 10:31:06.000000000 -0700
@@ -23,6 +23,7 @@
 
 #include <stdint.h>
 #include <list>
+#include <unordered_map>
 
 #include "ns3/packet.h"
 #include "ns3/nstime.h"
@@ -30,7 +31,6 @@
 #include "ns3/ipv6-address.h"
 #include "ns3/ptr.h"
 #include "ns3/timer.h"
-#include "ns3/sgi-hashmap.h"
 #include "ns3/output-stream-wrapper.h"
 
 namespace ns3
@@ -343,6 +343,12 @@
      * \param ipv6Address IPv6 address
      */
     void SetIpv6Address (Ipv6Address ipv6Address);
+    
+    /**
+     * \brief Get the IPv6 address.
+     * \returns The IPv6 address
+     */
+    Ipv6Address GetIpv6Address (void) const;
 
     /**
      * \brief Print this entry to the given output stream.
@@ -421,11 +427,11 @@
   /**
    * \brief Neighbor Discovery Cache container
    */
-  typedef sgi::hash_map<Ipv6Address, NdiscCache::Entry *, Ipv6AddressHash> Cache;
+  typedef std::unordered_map<Ipv6Address, NdiscCache::Entry *, Ipv6AddressHash> Cache;
   /**
    * \brief Neighbor Discovery Cache container iterator
    */
-  typedef sgi::hash_map<Ipv6Address, NdiscCache::Entry *, Ipv6AddressHash>::iterator CacheI;
+  typedef std::unordered_map<Ipv6Address, NdiscCache::Entry *, Ipv6AddressHash>::iterator CacheI;
 
   /**
    * \brief A list of Entry.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/nsc-tcp-l4-protocol.cc ns-3.34/src/internet/model/nsc-tcp-l4-protocol.cc
--- ns-3.33/src/internet/model/nsc-tcp-l4-protocol.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/nsc-tcp-l4-protocol.cc	2021-07-14 10:31:06.000000000 -0700
@@ -89,8 +89,12 @@
    *
    * Its also used by the cradle code to add a timestamp to
    * printk/printf/debug output.
+   *
+   * \param [out] sec seconds
+   * \param [out] usec microseconds
+   *
    */
-  virtual void gettime (unsigned int *, unsigned int *);
+  virtual void gettime (unsigned int *sec, unsigned int *usec);
 private:
   Ptr<NscTcpL4Protocol> m_prot; //!< the NSC TCP protocol
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/rip.cc ns-3.34/src/internet/model/rip.cc
--- ns-3.33/src/internet/model/rip.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/rip.cc	2021-07-14 10:31:06.000000000 -0700
@@ -493,10 +493,15 @@
   NS_LOG_FUNCTION (this << stream);
 
   std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", IPv4 RIP table" << std::endl;
 
   if (!m_routes.empty ())
@@ -511,11 +516,11 @@
             {
               std::ostringstream dest, gw, mask, flags;
               dest << route->GetDest ();
-              *os << std::setiosflags (std::ios::left) << std::setw (16) << dest.str ();
+              *os << std::setw (16) << dest.str ();
               gw << route->GetGateway ();
-              *os << std::setiosflags (std::ios::left) << std::setw (16) << gw.str ();
+              *os << std::setw (16) << gw.str ();
               mask << route->GetDestNetworkMask ();
-              *os << std::setiosflags (std::ios::left) << std::setw (16) << mask.str ();
+              *os << std::setw (16) << mask.str ();
               flags << "U";
               if (route->IsHost ())
                 {
@@ -525,8 +530,8 @@
                 {
                   flags << "GS";
                 }
-              *os << std::setiosflags (std::ios::left) << std::setw (6) << flags.str ();
-              *os << std::setiosflags (std::ios::left) << std::setw (7) << int(route->GetRouteMetric ());
+              *os << std::setw (6) << flags.str ();
+              *os << std::setw (7) << int(route->GetRouteMetric ());
               // Ref ct not implemented
               *os << "-" << "      ";
               // Use not implemented
@@ -544,6 +549,8 @@
         }
     }
   *os << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 void Rip::DoDispose ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/model/ripng.cc ns-3.34/src/internet/model/ripng.cc
--- ns-3.33/src/internet/model/ripng.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/model/ripng.cc	2021-07-14 10:31:06.000000000 -0700
@@ -473,10 +473,11 @@
   NS_LOG_FUNCTION (this << stream);
 
   std::ostream* os = stream->GetStream ();
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv6->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv6->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", IPv6 RIPng table" << std::endl;
 
   if (!m_routes.empty ())
@@ -492,9 +493,9 @@
               std::ostringstream dest, gw, mask, flags;
 
               dest << route->GetDest () << "/" << int(route->GetDestNetworkPrefix ().GetPrefixLength ());
-              *os << std::setiosflags (std::ios::left) << std::setw (31) << dest.str ();
+              *os << std::setw (31) << dest.str ();
               gw << route->GetGateway ();
-              *os << std::setiosflags (std::ios::left) << std::setw (27) << gw.str ();
+              *os << std::setw (27) << gw.str ();
               flags << "U";
               if (route->IsHost ())
                 {
@@ -504,8 +505,8 @@
                 {
                   flags << "G";
                 }
-              *os << std::setiosflags (std::ios::left) << std::setw (5) << flags.str ();
-              *os << std::setiosflags (std::ios::left) << std::setw (4) << int(route->GetRouteMetric ());
+              *os << std::setw (5) << flags.str ();
+              *os << std::setw (4) << int(route->GetRouteMetric ());
               // Ref ct not implemented
               *os << "-" << "   ";
               // Use not implemented
